--$Name: Starfighter$
--$Version:1.2$
instead_version "1.4.0"
require "sprites"
require "timer"
require "kbd"
require "sound"
require "prefs"

spr = {}
star = {}
MAX = 30

keys = {};
frames = 0;
prefs.hiscore = 0
title_nr = 1

titr = {
	"Version 1.2";
	"INSTEAD '2009-2011";
	"Keys: left, right, space";
	"Press escape for menu";
	"Press space to start game";
	"http://instead.syscall.ru";
};

function init()
	t1 = os.time(os.date("*t"))

	fn = sprite.font("font.ttf", 16);
	game_over = sprite.text(fn, "Game Over!", "white");
	starfighter = sprite.text(fn, "Get Ready, Starfighter!", "white");

	spr[1] = sprite.load("pic/fon2.png");
	spr[3] = sprite.load("pic/mars.png");
	spr[4] = sprite.load("pic/fire.png");
	spr[11] = sprite.load("pic/meteor.png");
	meteor_w, meteor_h = sprite.size(spr[11]);
	shot_w, shot_h = sprite.size(spr[4]);
	spr[44] = sprite.scale(spr[4], 1.0, -1.0);
	spr[5] = sprite.load("pic/fonly.png");
	spr[6] = sprite.load("pic/fonry.png");
	spr[10] = sprite.load("pic/ship.png");
	ship_w, ship_h = sprite.size(spr[10]);

	spr[12] = sprite.load("pic/bonusf.png");
	bonus_w, bonus_h = sprite.size(spr[12]);
	spr[13] = sprite.load("pic/bonuss.png");
	
	spr[204] = sprite.load("pic/alien4m.png");
	alien_w, alien_h = sprite.size(spr[204])
	spr[205] = sprite.load("pic/alien6.png");
	spr[901] = sprite.load("pic/boom1.png");
	explode_w, explode_h = sprite.size(spr[901])
	spr[902] = sprite.load("pic/boom2.png");
	spr[903] = sprite.load("pic/boom3.png");
	spr[904] = sprite.load("pic/boom4.png");
	spr[905] = sprite.load("pic/boom5.png");
	spr[906] = sprite.load("pic/boom6.png");
	spr[907] = sprite.load("pic/boom7.png");
	spr[908] = sprite.load("pic/boom8.png");
	local i
	for i=1, MAX do
		star[i] = {}
		star[i].x=rnd(500);
		star[i].y=rnd(700);
		star[i].speed=rnd(4);
	end
	fon_y = 0
	fon_y2 = -700
	lfon_y=0;
	lfon_y2=-700;
	rfon_y=0;
	rfon_y2=-700;
	hook_keys('right', 'left', 'space');
	set_music 'eq.xm'
	boom = sound.load 'damag.wav'
	torp = sound.load 'firetorp.wav'
	bon = sound.load 'bonus.wav'
	titles = true
	title_frame = 0
end
function start()
	wave_nr = 0
	ship_accel = 0
	shots = {}
	eshots = {}
	aliens = {}
	meteors = {}
	bonuses = {}
	last_shot = -100
	explodes = {}
	seed=12345
	seed2=543271
	score = 0;
	bonus_fire = 0;
	bonus_speed = 0
	ship_x = 500 / 2;
	ship_y = 700 - ship_h / 2
	ship_dead = false
	dead_time = 0
	game:timer()
	timer:set(25)
end
function starwind()
	local i
	for i=1,MAX do
		sprite.pixel(sprite.screen(), star[i].x, star[i].y, 'white');
		star[i].y = star[i].y + star[i].speed
		if star[i].y > 700 then star[i].y = -20 end
		if star[i].x > 640 then star[i].x = rnd(640) - 250 end
	end
end
game.timer = function(s)
	frames = frames + 1
	sprite.copy(spr[1], sprite.screen(), 0, fon_y);
	sprite.copy(spr[1], sprite.screen(), 0, fon_y2);


	fon_y2 = fon_y2 + 1;
	fon_y = fon_y + 1;
	if fon_y2 == 700 then fon_y2 = -700 end
	if fon_y == 700 then fon_y = -700 end
	sprite.draw(spr[3], sprite.screen(),300, -50 + wave_nr);
	sprite.draw(spr[5], sprite.screen(),-20,lfon_y);	
	sprite.draw(spr[5], sprite.screen(),-20,lfon_y2);	
	lfon_y = lfon_y + 1.5;
	lfon_y2 = lfon_y2 + 1.5;
	if lfon_y>=700 then lfon_y=-700 end
	if lfon_y2>=700 then lfon_y2=-700 end
	sprite.draw(spr[6],sprite.screen(), 440, rfon_y);	
	sprite.draw(spr[6],sprite.screen(), 440, rfon_y2);	
	rfon_y=rfon_y + 1.5;
	rfon_y2 = rfon_y2 + 1.5;
	if rfon_y>=700 then rfon_y=-700 end
	if rfon_y2>=700 then rfon_y2=-700 end
	starwind()
	bonus();
	meteor();
	fire();
	enemy();
	explode();
	wave();
	ship();
	if t2 and os.time(os.date("*t")) - t2 > 1 then -- menu?
		frames = 0
		last_shot = 0
		t1 = os.time(os.date("*t"))
	end
	t2 = os.time(os.date("*t"))
	if (math.abs(t2 - t1) > 1) then
		local n = math.ceil(frames / (t2 - t1))
		local fps = sprite.text(fn, "fps: "..tostring(n), 'white');
		local w, h = sprite.size(fps);
		sprite.draw(fps, sprite.screen(), 500 - w, h);
		sprite.free(fps);
	end
end

game.kbd = function(s, down, key)
	keys[key] = down
end

function ship()
	local w,h
	local sscore = sprite.text(fn, "HI: "..tostring(prefs.hiscore), 'cyan');
	w,h = sprite.size(sscore);
	sprite.draw(sscore, sprite.screen(), 0, 0);
	sprite.free(sscore);

	sscore = sprite.text(fn, "Score: "..tostring(score), 'white');
	sprite.draw(sscore, sprite.screen(), 0, h);
	sprite.free(sscore);


	local wavenr = sprite.text(fn, "Wave: "..tostring(wave_nr), 'cyan');
	w, h = sprite.size(wavenr);
	sprite.draw(wavenr, sprite.screen(), 500 - w, 0);
	sprite.free(wavenr);

	if titles or ship_dead then
		if ship_dead then
			w,h = sprite.size(game_over);
			sprite.draw(game_over, sprite.screen(), (500 - w) / 2, (700 - h)/2);
		else
			w,h = sprite.size(starfighter);
			sprite.draw(starfighter, sprite.screen(), (500 - w) / 2, (700 - h)/2 - h);
		end
		local t = sprite.text(fn, titr[title_nr], "white");
		w,h = sprite.size(t)
		sprite.draw(t, sprite.screen(), (500 - w) / 2, (700 - h));
		sprite.free(t)
		if frames - title_frame > 90 then
			title_frame = frames
			title_nr = title_nr + 1
			if title_nr > #titr then
				title_nr = 1
			end
		end
		return
	end

	if keys["right"] and ship_x < 500 - 1.5 * ship_w then
		ship_accel = ship_accel + (0.5 + bonus_speed);
		if ship_accel > 6 then
			ship_accel = 6
		end
	elseif keys["left"] and ship_x > 1.5 * ship_w then
		ship_accel = ship_accel - (0.5 + bonus_speed);
		if ship_accel < -6 then
			ship_accel = -6
		end
	else
		ship_accel = ship_accel / 1.1
	end
	ship_x = ship_x + ship_accel
	if ship_x < ship_w then
		ship_x = ship_w 
	elseif ship_x > 500 - ship_w then
		ship_x = 500 - ship_w
	end
	sprite.draw(spr[10], sprite.screen(), ship_x - ship_w / 2, ship_y - ship_h/2);
end

function fire()
	local i
	local shots2 = {}
	if ship_dead or titles then
		dead_time = dead_time + 1
	end
	if ( ship_dead or titles ) and keys["space"] and ( dead_time > 60 or titles) then
		keys["space"] = false
		titles = false
		start()
	end
	if not ship_dead and not titles and keys["space"] then
		local delay = (bonus_fire % 5) + 1
		local num = math.floor(bonus_fire / 5 + 1)
		if frames - last_shot > 15 - delay then
			last_shot = frames
			if num == 1 then
				table.insert(shots, { x = ship_x, y = ship_y - shot_h });
			elseif num == 2 then
				table.insert(shots, { x = ship_x - shot_w, y = ship_y - shot_h });
				table.insert(shots, { x = ship_x + shot_w, y = ship_y - shot_h });
			elseif num == 3 then
				table.insert(shots, { x = ship_x - shot_w, y = ship_y - shot_h });
				table.insert(shots, { x = ship_x, y = ship_y - shot_h });
				table.insert(shots, { x = ship_x + shot_w, y = ship_y - shot_h });
			else
				table.insert(shots, { x = ship_x - 2 * shot_w, y = ship_y - shot_h });
				table.insert(shots, { x = ship_x - shot_w, y = ship_y - shot_h });
				table.insert(shots, { x = ship_x, y = ship_y - shot_h });
				table.insert(shots, { x = ship_x + shot_w, y = ship_y - shot_h });				
				table.insert(shots, { x = ship_x + 2 * shot_w, y = ship_y - shot_h });				
			end
			sound.play(torp)
		end
	end
	for i=1, #shots do
		sprite.draw(spr[4], sprite.screen(), shots[i].x - shot_w / 2, shots[i].y - shot_h / 2) 
		shots[i].y = shots[i].y - shot_h / 2;
		if shots[i].y > 0 then
			table.insert(shots2, shots[i]);
		end
	end
	shots = shots2;
	shots2 = {}
	for i=1, #eshots do
		sprite.draw(spr[44], sprite.screen(), eshots[i].x - shot_w / 2, eshots[i].y - shot_h / 2) 
		if not ship_dead and not titles and math.abs(eshots[i].x - ship_x) < ship_w/2 and
				math.abs(eshots[i].y - ship_y) < ship_h/2 then
			table.insert(explodes, { x = ship_x, y = ship_y, step = 1 } );
			ship_dead = true
			title_frame = frames
			prefs:store()
		else
			eshots[i].y = eshots[i].y + shot_h;
			if eshots[i].y < 700 + shot_h then
				table.insert(shots2, eshots[i]);
			end
		end
	end
	eshots = shots2;
end

function meteor()
	local i,k
	local meteors2 = {}
	for i=1, #meteors do
		sprite.draw(spr[11], sprite.screen(), meteors[i].x - meteor_w / 2, meteors[i].y - meteor_h / 2) 
		meteors[i].y = meteors[i].y + meteors[i].speed
		if not ship_dead and not titles and math.abs(meteors[i].x - ship_x) < ship_w/2 + meteor_w/2 and
				math.abs(meteors[i].y - ship_y) < ship_h/2 + meteor_h/2 then
			table.insert(explodes, { x = ship_x, y = ship_y, step = 1 } );
			ship_dead = true
			title_frame = frames
			prefs:store()
		end
		for k=1, #shots do
			if math.abs(meteors[i].x - shots[k].x) < meteor_w/2 and
				math.abs(meteors[i].y - shots[k].y) < meteor_h/2 then
				table.insert(explodes, { x = shots[k].x, y = shots[k].y, step = 1 } );
				table.remove(shots, k);
				break
			end
		end

		if meteors[i].y < 700 + meteor_h then
			table.insert(meteors2, meteors[i]);
		end
	end
	meteors = meteors2;
end

function bonus()
	local i
	local bonuses2 = {}
	for i=1, #bonuses do
		sprite.draw(spr[bonuses[i].t + 11], sprite.screen(), bonuses[i].x - bonus_w / 2, bonuses[i].y - bonus_h / 2) 
		bonuses[i].y = bonuses[i].y + 2
		if not ship_dead and not titles and math.abs(bonuses[i].x - ship_x) < bonus_w/2 and
				math.abs(bonuses[i].y - ship_y) < bonus_h/2 then
				sound.play(bon)
				if bonuses[i].t == 1 then -- fire bonus
					bonus_fire = bonus_fire + 2
					if bonus_fire > 15 then
						bonus_fire = 15
					end
				else
					bonus_speed = bonus_speed + 0.2
					if bonus_speed > 2 then
						bonus_speed = 2
					end
				end
		elseif bonuses[i].y < 700 + meteor_h then
			table.insert(bonuses2, bonuses[i]);
		end
	end
	bonuses = bonuses2;
end



function enemy()
	local i,k
	local aliens2 = {}
	for i=1, #aliens do
		if aliens[i].t == 2 then
			sprite.draw(spr[205], sprite.screen(), aliens[i].x - alien_w / 2, aliens[i].y - alien_h / 2) 
		else
			sprite.draw(spr[204], sprite.screen(), aliens[i].x - alien_w / 2, aliens[i].y - alien_h / 2) 
		end
		aliens[i].y = aliens[i].y + 4
		aliens[i].x, aliens[i].y = aliens[i].fn(i);
		if not aliens[i].shot and rnd(100) < 2 and aliens[i].y > 0 and aliens[i].t == 1 and wave_nr>= 2 then
			table.insert(eshots, { x = aliens[i].x, y = aliens[i].y + shot_h });
			aliens[i].shot = true
		end

		if not ship_dead and not titles and math.abs(aliens[i].x - ship_x) < alien_w/2 and
				math.abs(aliens[i].y - ship_y) < alien_h/2 then
			aliens[i].dead = true
			table.insert(explodes, { x = aliens[i].x, y = aliens[i].y, step = 1 } );
			table.insert(explodes, { x = ship_x, y = ship_y, step = 1 } );
			ship_dead = true
			title_frame = frames
			prefs:store()
		end	
		for k=1, #shots do
			if math.abs(aliens[i].x - shots[k].x) < alien_w/2 and
				math.abs(aliens[i].y - shots[k].y) < alien_h/2 then
				table.remove(shots, k);
				table.insert(explodes, { x = aliens[i].x, y = aliens[i].y, step = 1 } );
				if aliens[i].t ~= 2 or aliens[i].hit then
					aliens[i].dead = true
					if aliens[i].bonus then
						table.insert(bonuses, { x = aliens[i].x, y = aliens[i].y, t = aliens[i].bonus });
					end
					if aliens[i].t == 2 then
						score = score + 30
					else
						score = score + 10
					end
					if score > prefs.hiscore then
						prefs.hiscore = score
					end
				end
				if aliens[i].t == 2 and not aliens[i].hit then
					aliens[i].hit = true
				end
				break
			end
		end
		if aliens[i].y < 700 + alien_h and not aliens[i].dead then
			table.insert(aliens2, aliens[i]);
		end 
	end
	aliens = aliens2
end
attack_fn = function(i)
	local x,y = aliens[i].x, aliens[i].y

	if ship_y - y > 1400 then
		return x, y + 2
	end

	d = -7/(6 * 700) * (ship_y - y) + 7/6
	if x < ship_x then
		x = x + d
	elseif x > ship_x then
		x = x - d
	end
	return x, y + 2
end

stright_fn = function(i)
	local x,y = aliens[i].x, aliens[i].y
	return x, y + 2
end

function explode()
	local i
	local explodes2 = {}
	for i=1, #explodes do
		if explodes[i].step == 1 then
			sound.play(boom)
		end
		sprite.draw(spr[math.floor(explodes[i].step) + 900],
			 sprite.screen(), 
			 explodes[i].x - explode_w / 2, 
			 explodes[i].y - explode_h / 2) 
		explodes[i].step = explodes[i].step + 0.5
		if explodes[i].step < 9 then
			table.insert(explodes2, explodes[i]);
		end
	end
	explodes = explodes2;
end


function prnd(x)
	seed = bit_mul(seed, 1103515245) + 1211347
	return  bit_mod(seed, x) + 1
end

function prnd2(x)
	seed2 = bit_mul(seed2, 1913511247) + 193571
	return  bit_mod(seed2, x) + 1
end

function build_awave(n)
	local i
	local y = n;
	for i=1,7 do
		local x = prnd(400) + 50
		y = y - alien_h * 2;
		table.insert(aliens, { x = x, y = y, fn = attack_fn, t = 1 });
	end
	return n - y
end

function build_bwave(n)
	local i
	local y = n;
	local n = 400 / alien_w;
	x = 25;
	for i=1,n do
		x = x + alien_w;
		table.insert(aliens, { x = x, y = y, fn = stright_fn, t = 1 });
	end
	return alien_w
end

function build_cwave(n)
	local i
	local y = n;
	local nn = 400 / alien_w;
	x = 50;
	for i=1,nn do
		x = x + alien_w;
		y = y - alien_h;
		table.insert(aliens, { x = x, y = y, fn = attack_fn, t = 1 });
	end
	return n - y
end

function build_dwave(yy)
	local i
	local y = yy;
	local n = 400 / alien_w;
	x = 450;
	for i=1,n do
		x = x - alien_w;
		y = y - alien_h;
		table.insert(aliens, { x = x, y = y, fn = attack_fn, t = 1 });
	end
	return yy - y
end

function build_ewave(n)
	local h = build_cwave(n)
	local hh = build_dwave(n - h)
	return h + hh
end

function build_fwave(yy)
	local i
	local y = yy;
	local n = 400 / alien_w;
	x = 450;
	for i=1,n/2 - 1 do
		x = x - alien_w;
		y = y - alien_h;
		table.insert(aliens, { x = x, y = y, fn = attack_fn, t = prnd(2) });
	end
	x = 50;
	y = yy;
	for i=1,n/2 do
		x = x + alien_w;
		y = y - alien_h;
		table.insert(aliens, { x = x, y = y, fn = attack_fn, t = prnd(2) });
	end
	return yy - y
end

function build_gwave(yy)
	local i
	local y = yy;
	local n = 400 / alien_w;
	x = 500 / 2 + alien_w;
	x = x - alien_w;
	y = y - alien_h;
	for i=1,n/2 - 1 do
		x = x - alien_w;
		y = y - alien_h;
		table.insert(aliens, { x = x, y = y, fn = attack_fn, t = prnd(2) });
	end
	x = 500 / 2 - alien_w;
	y = yy;
	for i=1,n/2 do
		x = x + alien_w;
		y = y - alien_h;
		table.insert(aliens, { x = x, y = y, fn = attack_fn, t = prnd(2) });
	end
	return yy - y
end


wave_types = {
	build_awave,
	build_bwave,
	build_cwave,
	build_dwave,
	build_ewave,
	build_fwave,
	build_gwave,
}

function wave()
	local i,k
	if #aliens == 0 then
		wave_nr = wave_nr + 1
		local n = (wave_nr / 5) + 1
		local t
		if wave_nr <= #wave_types then
			t = wave_nr
			m = 0
		else
			t = #wave_types
			m = wave_nr / 7;
		end
		local h = -alien_h
		for i=1, n do
			local w = prnd(t)
			h = h - wave_types[w](h);
			h = h - alien_h;
		end
		for i=1,m do
			table.insert(meteors, { x = prnd(400) + 50, y = -prnd(700), speed = prnd(4) + 1 });
		end
		if prnd2(30) <= 20 then
			k = prnd2(#aliens);
			aliens[k].bonus = prnd2(2)
		end
	end
end
main.dsc = [[Please, enable game themes in settings.]]